// $Id$
#include <iostream>
#include <cstring>

class HelloTest {
private:
  size_t len;
  char *heap;

public:
  HelloTest(void);
  HelloTest(size_t len);
  ~HelloTest(void);
  HelloTest(const HelloTest &hello);

  void print(void);
};


HelloTest::HelloTest(void)
{
  this->len = 0;
  this->heap = NULL;
}

HelloTest::HelloTest(size_t len)
{
  this->len = len;
  this->heap = new char[len];
  memset(this->heap, 0, sizeof(char)*len);
}

HelloTest::~HelloTest(void)
{
  if (heap != NULL) {
    delete[] heap;
  }
}

HelloTest::HelloTest(const HelloTest &hello)
{
  this->len = hello.len;
  this->heap = new char[hello.len];
  memcpy(this->heap, hello.heap, sizeof(char)*(hello.len));
}

void HelloTest::print(void)
{
  std::cout << "Hello, world!" << std::endl;
}


int main(int argc, char **argv)
{
  int len = atoi(argv[1]);
  int n = atoi(argv[2]);
  for (int i = 0; i < n; i++) {
    HelloTest *hello;
    hello = new HelloTest(len);
    hello->print();
    delete hello;
  }
  return EXIT_SUCCESS;
}
