/* $Id$ */
#include <stdio.h>
#include <stdlib.h>

#define XMALLOC(type, num) ((type *)malloc((num)*sizeof(type)))
#define XCALLOC(type, num) ((type *)calloc((num), sizeof(type)))
#define XFREE(stale) do { if (stale != NULL) { free(stale); stale = NULL; } } while(0)

struct hello {
  size_t len;
  char *heap;
};
typedef struct hello Hello;

static Hello *hello_init(size_t len);
static void hello_free(Hello *hello);
static void hello_print(Hello *hello);

int main(int argc, char **argv)
{
  Hello *hello;
  int i, n, len;
  len = atoi(argv[1]);
  n = atoi(argv[2]);
  for (i = 0; i < n; i++) {
    hello = hello_init(len);
    hello_print(hello);
    hello_free(hello);
  }
  return EXIT_SUCCESS;
}

static Hello *hello_init(size_t len)
{
  Hello *p;
  p = XMALLOC(Hello, 1);
  p->len = len;
  p->heap = XCALLOC(char, len);
  return p;
}

static void hello_free(Hello *hello)
{
  XFREE(hello->heap);
  XFREE(hello);
}

static void hello_print(Hello *hello)
{
  printf("Hello, world!\n");
}
